"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const package_1 = __importDefault(require("../package"));
const production_1 = __importDefault(require("../production"));
const consume_1 = __importDefault(require("./consume"));
const resolvePath_1 = __importDefault(require("./resolvePath"));
const settings_1 = __importStar(require("./settings"));
const find_up_1 = __importDefault(require("find-up"));
const node_path_1 = __importDefault(require("node:path"));
const cwd = process.cwd();
const { DIGEST_NAME = 'digest.config.json' } = process.env;
const digestPath = find_up_1.default.sync(DIGEST_NAME);
const digestConfig = digestPath ?
    require(digestPath) :
    {};
const config = settings_1.keys.reduce((prev, key) => {
    var _a, _b, _c, _d, _e;
    const { defaults, env: envKey, packageName, resolve, type } = settings_1.default[key];
    const envSetting = process.env[envKey];
    const transformedEnvSetting = (0, consume_1.default)(type, envSetting);
    const configSetting = digestConfig[key];
    const transformedConfigSetting = (0, consume_1.default)(type, configSetting);
    const userSetting = (_a = transformedEnvSetting !== null && transformedEnvSetting !== void 0 ? transformedEnvSetting : transformedConfigSetting) !== null && _a !== void 0 ? _a : defaults;
    const verifiedSetting = userSetting &&
        packageName ?
        ((0, resolvePath_1.default)(packageName) ?
            userSetting :
            false) :
        userSetting;
    const resolveSetting = verifiedSetting &&
        resolve ?
        (0, resolvePath_1.default)(verifiedSetting, true) :
        verifiedSetting;
    switch (key) {
        case 'cache': {
            prev[key] = resolveSetting ?
                node_path_1.default.join(cwd, resolveSetting) :
                resolveSetting;
            break;
        }
        case 'reports': {
            prev[key] = resolveSetting === 'reports' ?
                node_path_1.default.join(cwd, 'reports') :
                resolveSetting;
            break;
        }
        case 'shortName': {
            prev[key] = (_e = (_b = transformedEnvSetting !== null && transformedEnvSetting !== void 0 ? transformedEnvSetting : transformedConfigSetting) !== null && _b !== void 0 ? _b : (_d = (_c = package_1.default === null || package_1.default === void 0 ? void 0 : package_1.default.name) === null || _c === void 0 ? void 0 : _c.replace('@', '')) === null || _d === void 0 ? void 0 : _d.replace('/', '-')) !== null && _e !== void 0 ? _e : 'nd';
            break;
        }
        default: {
            prev[key] = resolveSetting;
        }
    }
    return prev;
}, {
    digestName: DIGEST_NAME
});
config.cache = config.cache ?
    node_path_1.default.join(config.cache, config.library ?
        'library' :
        (production_1.default ?
            'production' :
            'development')) :
    config.cache;
config.staticPath = config.staticPath === 'public' ?
    node_path_1.default.join(cwd, config.library ?
        'lib' :
        'public') :
    config.staticPath;
config.context = node_path_1.default.join(process.cwd(), config.sourcePath);
exports.default = config;
